<template>
  <div class="product-list">

    <v-container fluid>
			<div class="d-flex align-start" >
				<v-col xs="12" sm="12" md="8" lg="8" xl="8"
					class="d-flex align-start justify-end" >
					<v-row no-gutters class="d-flex align-start flex-column" style="width: 100%;">
              <v-col cols="12" :key="p.product.id" v-for="(p, index) in cart.cartProducts" class="mb-2">
                
                <div class="d-flex justify-space-between mb-2">
                  <h2> {{p.product.name}}</h2>
                <h2>{{fullLocation(p.product.store)}}</h2>
                </div>
                <v-card class="d-flex">
                  <v-row no-gutters>
                    <v-col class="d-flex flex-column">
                      <v-row no-gutters>
                      <v-col cols="auto" class="d-flex">
                        <router-link :to="'/products/'+p.product.id">
                          <v-img
                            class="white--text align-end"
                            height="125px"
                            width="125px"
                            src="https://cdn.vuetifyjs.com/images/cards/docks.jpg"
                          >
                          </v-img>
                        </router-link>
                      </v-col>

                      <v-col class="px-4 py-2">
                        <v-row>
                          <v-col cols="6">
                            <v-menu
                          v-model="menu[index]"
                          :close-on-content-click="false"
                          :nudge-right="40"
                          transition="scale-transition"
                          style="padding: 0px;"
                          min-width="150px"
                        >
                          <template v-slot:activator="{ on, attrs }">
                            <v-text-field 
                              :value="formatDate(startDates[index])"
                              v-bind="attrs"
                              v-on="on"
                              @click="selectedCartProductId = p.product.id; selectedPicker = 'start'; currentIndex = index"
                              style="padding: 0px;"
                              label="Début de la location" 
                              readonly></v-text-field>
                          </template>
                          <v-date-picker 
                            v-model="startDates[index]"
                            locale="fr-fr" 
                            :min="nowDate"
                            :allowed-dates="getAllowedDates"
                            no-title></v-date-picker>
                        </v-menu>
                      </v-col>
                      <v-col cols="6">
                        <v-menu
                          v-model="menuEnd[index]"
                          :close-on-content-click="false"
                          :nudge-right="40"
                          transition="scale-transition"
                          offset-y 
                          style="padding: 0px;"
                          min-width="150px"
                        >
                          <template v-slot:activator="{ on, attrs }">
                            <v-text-field 
                              :value="formatDate(endDates[index])"
                              v-bind="attrs"
                              v-on="on"
                              @click="selectedCartProductId = p.product.id; selectedPicker = 'end'; currentIndex = index"
                              style="padding: 0px;"
                              label="Fin de la location" 
                              readonly></v-text-field>
                          </template>
                          <v-date-picker 
                            v-model="endDates[index]"
                            locale="fr-fr" 
                            :allowed-dates="getAllowedDates"
                            :min="nowDate"
                            no-title></v-date-picker>
                        </v-menu>
                        </v-col>

                        <v-col cols="12" class="mt-n8">
                        <div class="text--primary"  style="height:55px;">
                        <div> {{p.product.description.length > 120 ? p.product.description.substring(0,120) + "..." : p.product.description }} </div>
                        </div>
                      </v-col>
                        </v-row>
                      </v-col>

                      <v-col cols="12" class="mt-n5 pb-0 pt-1 mb-1">
                        <v-row no-gutters>
                          <div style="width:125px;">
                            <div v-if="p.product.notation" class="body-2 my-2 d-flex justify-center">
                              <star-rating 
                              style="margin-left: 5px;"
                              :inline="true" 
                              :star-size="15"
                              :read-only="true" 
                              :show-rating="false" 
                              :rating="p.product.notation"
                              :round-start-rating="false" ></star-rating>
                            </div>
                            <div v-else class="body-2 pl-1 text-center">
                              <i> Aucune note</i>
                            </div>
                          </div>
                          <div class="px-4 d-flex justify-space-between" style="width: calc(100% - 125px);">
                              <span>Prix journalier pour le produit: <b>{{p.product.price}}€</b></span>
                              <span>Prix de la location pour le produit: <b>{{Math.round(locationPrice(index) * 100) / 100}}€</b></span>
                          </div>
                        </v-row>
                      </v-col>
                    </v-row>
                  </v-col>

                  <v-col cols="auto"> 
                    <v-btn x-small color="red" @click="removeCart(p.product)" style="height:100%; color: white; border-top-left-radius: 0px !important; border-bottom-left-radius: 0px !important">
                      <v-icon style="text-decoration: none;">mdi-cart-remove</v-icon>
                    </v-btn>
                  </v-col>
                    </v-row>
                  </v-card>
              </v-col>
					</v-row>
				</v-col>

				<v-col xs="6" sm="6" md="4" lg="4" xl="4"
					class="d-flex align-start justify-start" >
          <v-card class="style-card mb-5 col-xs-12 col-sm-12 col-md-12 col-lg-12 col-xl-12">
            <div 
            class="d-flex flex-column">
              <span>Nom de réservation: {{userInfos.lastName}} {{userInfos.firstName}}</span>
              <span>Numéro de téléphone: {{userInfos.phone}}</span>
              <span>Adresse de facturation: Ma merveilleuse adresse</span>
              <br/>

              <v-row no-gutters class="d-flex">
                <v-col cols="7">
                  <v-text-field 
                  v-model="promoCodeText"
                  style="padding: 0px;"
                  label="Code Promo"
                  ></v-text-field>
                </v-col>
                <v-spacer/>
                <v-col cols="4">
                  <v-btn
                    @click="checkPromoCode"
                    color="blue" 
                    class="mb-sm-0 p-2" 
                    style="color: white;"> Appliquer
                  </v-btn>
                </v-col>

                <v-col cols="12" class="mb-2">
                  <div v-if="codeChecked">
                    <div v-if="falseCode === false">
                      <i style="font-size: 0.85em; color: green;">Code appliqué.</i>
                    </div>
                    <div v-else-if="falseCode === true">
                      <i style="font-size: 0.85em; color: red;">Ce code ne permet aucune réduction sur les produits sélectionnés.</i>
                    </div>
                    <div v-else-if="falseCode === null && promoCode.id === undefined">
                      <i style="font-size: 0.85em; color: red;">Ce code n'existe pas.</i>
                    </div>
                  </div>
                </v-col>
              
              </v-row>  
              <span>Prix total de la location: {{Math.round(totalLocationPrice() * 100) / 100}}€</span>
            </div>
            
            <v-card-actions
              class="d-flex align-center">
                
              <div
                class="d-flex flex-column"
                style="width:100%;">
                
                <v-dialog v-model="dialog" persistent max-width="50%">
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn 
                      :disabled="btnDisabled"
                      v-bind="attrs"
                      v-on="on" 
                      color="green" 
                      class="mb-2 mb-sm-0" 
                      style="color: white; width: 25%;">
                      <v-icon style="text-decoration: none;">mdi-credit-card-outline</v-icon> Louer
                    </v-btn>
                  </template>
                  <v-card>
                    <v-card-title class="headline">Confirmation de location</v-card-title>
                    <PaymentShow v-bind:price="Math.round(totalPrice * 100) / 100" v-bind:cart="this.tabPayment" />
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn color="blue darken-1" text @click="dialog = false">Annuler</v-btn>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
                <div v-if="btnDisabled && this.cart.cartProducts !== undefined && cart.cartProducts.length > 0">
                  <i style="font-size: 0.85em; color: red;">Veuillez remplir toutes les dates de locations des produits du panier.</i>
                </div>
              </div>
              
            </v-card-actions>
          </v-card>
				</v-col>
        
			</div>
      
    </v-container>
  </div>
</template>

<script>

import { mapActions } from 'vuex';
import { mapFields } from 'vuex-map-fields';
import StarRating from 'vue-star-rating';
import moment from 'moment';
import PaymentShow from '../payment/Show';

export default {
  name: 'CartList',
  servicePrefix: 'Cart',
  components: {
    StarRating,
    PaymentShow,
  },
  data() {
    return {
      startDates: [],
      endDates: [],
      menu: [],
      menuEnd: [],
      btnDisabled: true,
      selectedPicker: '',
      msgError: [],
      currentIndex: -1,
      tabPayment: [],
      selectedCartProductId: undefined,
      totalPrice: '',
      dialog: false,
      nowDate: new Date().toISOString().slice(0,10),
      promoCodeText: '',
      codeChecked: false,
      falseCode: null,
    }
  },
  computed: {
    ...mapFields('cart', {
      cart: 'cart',
      excludedDates: 'excludedDates',
    }),
    ...mapFields('cart', ['cartLoaded']),
    ...mapFields('user', ['userInfos']),
    ...mapFields('adminPromoCode', ['promoCode']),
     getStartDate() {
      var date =  new Date(); 
      var startDate = new Date(date.getFullYear(), date.getMonth() + 3, 10);
      return startDate.toISOString().slice(0,10)
    },
    getEndDate() {
      var date =  new Date(); 
      var endDate = new Date(date.getFullYear(), date.getMonth() + 3, 10);
      return endDate.toISOString().slice(0,10)
    },
  },
  mounted: function () {
    this.$nextTick(function () {
      this.getCart();
      this.getProfile(this.userInfos.id);
      this.passPaymentFalse();
      this.setDefaultCodePromo();
    })
  },
  watch: {
    cartLoaded(value) {
      if (value === true) {
        this.getExcludedDates(this.cart.id)
      }   
    }
  },
  methods: {
    ...mapActions('cart', ['getCart', 'removeProductCart', 'getExcludedDates', 'toggleCartLoaded']),
    ...mapActions('user', ['getProfile']),
    ...mapActions('payment', ['passPaymentFalse']),
    ...mapActions('adminPromoCode', ['checkValidityPromoCode', 'setDefaultCodePromo']),
    fullLocation: item => item.street + ' - ' + item.zc + item.city + ', ' + item.country,
    checkPromoCode(){
      this.codeChecked = true
      this.checkValidityPromoCode(this.promoCodeText);
      setTimeout(function() {
        if(this.cart.cartProducts.some((cartProduct, index) => this.codeExists(index))){
          this.falseCode = false;
          this.tabPayment["promoCode"] = this.promoCode;
        } else if (this.promoCode.id === undefined) {
          this.falseCode = null;
        } else {
          this.falseCode = true;
        }
      }.bind(this), 1000)
    },
    removeCart: function(product){
      this.removeProductCart({productId: product.id, cartId: this.cart.id});
      setTimeout(() => this.getCart(), 500);
    },
    formatDate (date) {
      if (!date) return null;

      const [year, month, day] = date.split('-');
      return `${day}/${month}/${year}`;
    },
    parseDate (date) {
      if (!date) return null;

      const [day, month, year] = date.split('/');
      return `${year}-${month.padStart(2, '0')}-${day.padStart(2, '0')}`;
    },
    locationPrice(index){
      for(var i = 0; i < this.cart.cartProducts.length; i++){
        this.msgError[i] = false;
      }
      if(this.startDates[index] && this.endDates[index]){
        if(moment(this.endDates[index]).diff(moment(this.startDates[index]), 'days') < 0){
          this.btnLouer = false;
          this.msgError[index] = true;
          return 0;
        }
        var diff = moment(this.endDates[index]).diff(moment(this.startDates[index]), 'days');
        if(diff == 0){
          diff = 1;
        }
        return diff * this.cart.cartProducts[index].product.price;
      }
      return 0;
    },
    codeExists(index) {
      return '/companies/'+this.cart.cartProducts[index].product.store.company.id == this.promoCode.company
    },
    applyPercentReduction(price) {
      return price * (1 - this.promoCode.sold / 100 )
    },
    applyRawReduction(price) {
      return price - this.promoCode.sold
    },
    totalLocationPrice(){
      var prixTotal = 0;
      var btnEnabled = true;

      if(this.cart.cartProducts){
        this.cart.cartProducts.forEach((cartProduct, index) => {
          var diff = moment(this.endDates[index]).diff(moment(this.startDates[index]), 'days');
          if(this.startDates[index] && this.endDates[index]) {
            if(diff == 0){
              diff = 1;
            }

            if(this.codeExists(index)){
                if (this.promoCode.isPercent) {
                  prixTotal += this.applyPercentReduction(diff * cartProduct.product.price)
                } else {
                  prixTotal += this.applyRawReduction(diff * cartProduct.product.price)
                }
            } else {
              prixTotal += diff * cartProduct.product.price
            }
          } else {
            btnEnabled = false;
          }
        });

        if (btnEnabled && this.cart.cartProducts !== undefined && this.cart.cartProducts.length > 0) {
          this.btnDisabled = false;
        }
      }
      
      this.totalPrice = prixTotal;
      this.tabPayment["products"] = this.cart;
      this.tabPayment["startDates"] = this.startDates;
      this.tabPayment["endDates"] = this.endDates;

      return prixTotal;
    },
    getAllowedDates(val) { 
      if (this.selectedCartProductId !== undefined) {
        var allowed = true;
        var dateDiff = [];

      if (this.selectedPicker == 'start') {
        if (this.endDates[this.currentIndex] !== undefined) {
          if(this.excludedDates[this.selectedCartProductId] !== undefined){
            this.excludedDates[this.selectedCartProductId].forEach(dateRange => {
              var posDiff = moment(this.endDates[this.currentIndex]).diff(moment(dateRange[1]), "days") - 1;
              if(posDiff >= 0){
                dateDiff.push(posDiff);
              }
            });
          }
          dateDiff = dateDiff.sort((a,b) => a-b)
          if (dateDiff.length > 0) {
          allowed = moment(val) >= moment(this.endDates[this.currentIndex]).subtract(dateDiff[0], "days") && moment(val) <= moment(this.endDates[this.currentIndex])
          } else {
            allowed = val <= this.endDates[this.currentIndex];
          }
        } else {
          var dateTested = true
          if(this.excludedDates[this.selectedCartProductId] !== undefined){
            for(var i = 0; i < this.excludedDates[this.selectedCartProductId].length; i++) {
              dateTested = val < this.excludedDates[this.selectedCartProductId][i][0] || val > this.excludedDates[this.selectedCartProductId][i][1]
              if (!dateTested) {
                break;
              }
            }
            allowed = dateTested
          }
        }
      } else {
        if (this.startDates[this.currentIndex] !== undefined) {
          if(this.excludedDates[this.selectedCartProductId] !== undefined){
            this.excludedDates[this.selectedCartProductId].forEach(dateRange => {
              var posDiff = moment(dateRange[0]).diff(moment(this.startDates[this.currentIndex]), "days") - 1;
              if(posDiff >= 0){
                dateDiff.push(posDiff);
              }
            });
          }
          dateDiff = dateDiff.sort((a,b) => a-b)
          if (dateDiff.length > 0) {
            allowed = moment(val) >= moment(this.startDates[this.currentIndex]) && moment(val) <= moment(this.startDates[this.currentIndex]).add(dateDiff[0], "days")
          } else {
            allowed = val >= this.startDates[this.currentIndex];
          }
        } else {
          var dateTested2 = true;
          if(this.excludedDates[this.selectedCartProductId] !== undefined){
            for(var j = 0; j < this.excludedDates[this.selectedCartProductId].length; j++) {
              dateTested2 = val < this.excludedDates[this.selectedCartProductId][j][0] || val > this.excludedDates[this.selectedCartProductId][j][1]
              if (!dateTested2) {
                break;
              }
            }
            allowed = dateTested2
          }
        }
      }
      return allowed;
      }
    },
  },
  
};
</script>
